#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n,k;
    cin >> n >> k;
    string s,l;
    cin >> s;
    l = s;
    sort(l.begin(),l.end());
    if(l == s){
        bool fr = true;
        cout << 1 << ' ';
        for(int i = 1;i < n;i++){
            while(s[i] == s[i-1] && fr) {
                cout << 1 << ' ';
                i++;
            }
            fr = false;
            cout << 2 << ' ';
        }
    }
    else{
        map<char,int> c;
        string x = "abcdefghijklmnopqrstuvwxyz";
        for(int i = 0;i < n;i++){
            c[s[i]]++;
            int mn = 200005;
            for(int j = 0;j < k;j++){
                mn = min(c[x[j]],mn);
            }
            cout << mn+1 << ' ';
        }
    }

    return 0;
}